#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "sgs.h"

MODULE = SGS		PACKAGE = SGS	PREFIX=sgs

int
sgsCreateSequence(name)
	const char *	name

int
sgsDropSequence(name)
	const char *	name

void
sgsCurrentValue(name)
	const char *	name
	PREINIT:
	SGAnswer a;
	PPCODE:
	{
	    a = sgsCurrentValue(name);
	    EXTEND(SP, 2);
	    PUSHs(sv_2mortal(newSViv(a.returnStatus)));
	    PUSHs(sv_2mortal(newSViv(a.value)));
	}

void
sgsNextValue(name)
	const char *	name
	PREINIT:
	SGAnswer a;
	PPCODE:
	{
	    a = sgsNextValue(name);
	    EXTEND(SP, 2);
	    PUSHs(sv_2mortal(newSViv(a.returnStatus)));
	    PUSHs(sv_2mortal(newSViv(a.value)));
	}

void
sgsCache(name)
	const char *	name
	PREINIT:
	SGAnswer a;
	PPCODE:
	{
	    a = sgsCache(name);
	    EXTEND(SP, 2);
	    PUSHs(sv_2mortal(newSViv(a.returnStatus)));
	    PUSHs(sv_2mortal(newSViv(a.value)));
	}

void
sgsIncrement(name)
	const char *	name
	PREINIT:
	SGAnswer a;
	PPCODE:
	{
	    a = sgsIncrement(name);
	    EXTEND(SP, 2);
	    PUSHs(sv_2mortal(newSViv(a.returnStatus)));
	    PUSHs(sv_2mortal(newSViv(a.value)));
	}

int
sgsSetCache(name, newCache)
	const char *	name
	unsigned char	newCache

int
sgsSetHostname(name)
	const char *	name

int
sgsSetIncrement(name, newIncrement)
	const char *	name
	unsigned int	newIncrement

int
sgsSetValue(name, newValue)
	const char *	name
	unsigned int	newValue
